      PROGRAM TZPOSV2
*
*       ணࠬ PZPOSV2
*
      include 'mpif.h'
*  ⠭ - ࠬ 
      INTEGER           DLEN_, IA, JA, IB, JB, IAF, JAF, IX, JX,
     $                  MB, N, NB, RSRC, CSRC,
     $                  MXLLDA, MXLLDB, MXLLDAF, MXLLDX, NRHS, NBRHS,
     $                  NOUT, MXLOCR, MXLOCC, MXRHSC, LWORK, LRWORK
      PARAMETER         ( DLEN_ = 9, IA = 1, JA = 1, IB = 1, JB = 1,
     $                  IAF = 1, JAF = 1, IX = 1, JX = 1,
     $                  N = 9, MB = 2, NB = 2, RSRC = 0, CSRC = 0,
     $                  MXLLDA = 5, MXLLDB = 5, MXLLDAF = 5, MXLLDX = 5,
     $                  NRHS = 1, NBRHS = 1, NOUT = 6, MXLOCR = 5,
     $                  MXLOCC = 4, MXRHSC = 1, LRWORK = 9, LWORK = 15 )
*     $                  MXLOCC = 4,MXRHSC = 1, LRWORK = -1,LWORK = -1 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'U' )
*
*  ६
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
*
*  ᨢ
      INTEGER           DESCA( DLEN_ ), DESCB( DLEN_ ),DESCAF( DLEN_ ),
     $                  DESCX( DLEN_ )
      DOUBLE PRECISION   RWORK( LRWORK ),
     $                   FERR(1), BERR(1)
*     $                  RWORK( 5 )
      DOUBLE COMPLEX    A( MXLLDA, MXLOCC ), B( MXLLDB, MXRHSC ),
     $                  X( MXLLDX, MXRHSC ), AF( MXLLDAF, MXLOCC ),
     $                   WORK1( NB ), WORK( LWORK )
*     $                   WORK( 15 ), WORK1(NB)
*
* 譨 ணࠬ
      EXTERNAL          BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                  DESCINIT, PDMATINIT, PZPOSV2, PZLAPRNT, SL_INIT
*
*   DATA
      DATA               NPROW / 2 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 )
     $   GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      CALL DESCINIT( DESCA, N, N, MB, NB, RSRC, CSRC, ICTXT, MXLLDA,
     $               INFO )
      CALL DESCINIT( DESCB, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDB, INFO )
*
      CALL DESCINIT( DESCAF, N, N, MB, NB, RSRC, CSRC, ICTXT, MXLLDAF,
     $               INFO )
      CALL DESCINIT( DESCX, N, NRHS, NB, NBRHS, RSRC, CSRC, ICTXT,
     $               MXLLDX, INFO )
*
*   A  B  ।  ⪥ ᮢ
*
      CALL PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )N, N, MB, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  DESCAF'
         WRITE( NOUT, FMT = 9985 )DESCAF
         WRITE( NOUT, FMT = * ) '  DESCX'
         WRITE( NOUT, FMT = 9985 )DESCX
         WRITE( NOUT, FMT = * ) ' A'
      END IF
 9985 FORMAT( / 9I5 /)
*
      CALL PZLAPRNT( N, N, A, IA, JA, DESCA, 0, 0, 'A', NOUT, WORK1 )
*
*      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*      WRITE( NOUT, FMT = * ) ' B'
*      END IF
*      CALL PZLAPRNT( N, NRHS, B, IB, JB, DESCB, 0, 0, 'B', NOUT, WORK1)
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL PZPOSV2 ( UPLO, N, NRHS, A, IA, JA, DESCA, AF, IAF, JAF,
     $              DESCAF, B, IB, JB, DESCB, X, IX, JX, DESCX,
     $              FERR, BERR, WORK, LWORK, RWORK, LRWORK, INFO )
*
*  १⮢ X
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
*         WRITE( NOUT, FMT = 9993 )WORK(1), IWORK(1)
         WRITE( NOUT, FMT = * ) '襭 X'
      END IF
*
      CALL PZLAPRNT( N, NRHS, X, IX, JX, DESCX, 0, 0, 'X', NOUT, WORK1)
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*      WRITE( NOUT, FMT = 8888 ) MYROW, MYCOL, I, FERR(I)
      PRINT 8888, MYROW, MYCOL, FERR(1)
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*      WRITE( NOUT, FMT = 8887 ) MYROW, MYCOL, I, BERR(I)
      PRINT 8887, MYROW, MYCOL, BERR(1)
      END IF
*
 8888 FORMAT( / (I2, I2, ' FERR  =', D16.8) /)
 8887 FORMAT( / (I2, I2, ' BERR  =', D16.8) /)
*
* ᢮ ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '  ணࠬ PZPOSV2' )
 9998 FORMAT( / ' 襭 A X = B ,' //
     $      '  A - ନ⮢ ⥫쭮 ।  ',
     $      I2, '  ', I2,',' /
     $       '      ࠧ  ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO =', I6 /)
* 9993 FORMAT( /' WORK(1) =', 2D16.8, '   RWORK(1) =', D16.8 )
      STOP
      END
*
      SUBROUTINE PDMATINIT( N, A, IA, JA, DESCA, B, IB, JB, DESCB,
     $                      INFO )
*
* PDMATINIT   ।  A  B
*          ⪥ ᮢ 2 x 3
*
* ࠬ
      INTEGER            DESCA( * ), DESCB( * ), N, IA, JA, IB, JB,
     $                   INFO
      DOUBLE COMPLEX     A( * ), B( * )
*
*  ६
      INTEGER            I, J
      DOUBLE COMPLEX     T, MO, Z
*
* 譨 ணࠬ
      EXTERNAL            PZELSET
*
* 믮塞 
*
      T = ( 2.0D0, 0.0D0 )
      MO = ( -1.0D0, 0.0D0 )
      Z = ( 0.0D0, 0.0D0 )
*
      DO 20 J = 1, N
      DO 10 I = 1, N
         IF( I.EQ.J ) THEN
             CALL PZELSET( A, I, J, DESCA, T )
         ELSE
             CALL PZELSET( A, I, J ,DESCA, Z )
         END IF
   10 CONTINUE
   20 CONTINUE
*
      CALL PZELSET( A, 9, 9, DESCA, (1.0D0, 0.0D0) )
*
      DO 40 I = 1, N-1
         J = I + 1
         CALL PZELSET( A, I, J, DESCA, MO )
   40 CONTINUE
*
      DO 50 J = 1, N-1
         I = J + 1
         CALL PZELSET( A, I, J, DESCA, MO )
   50 CONTINUE
*
      J = 1
      DO 30 I = 1, N
        CALL PZELSET( B, I, J, DESCB, Z )
   30 CONTINUE
*
      CALL PZELSET( B, 9, 1, DESCB, (1.0D0, 0.0D0) )
*
      RETURN
      END
